from rocolib.api.components.Component import Component

c = Component()

#NEEDS CLEANING - NOT YET COMPLETE

#Don't change n yet, haven't figured out how to make it n-wheeled
#8-Wheeled Pivot Car
n = 5 #(# of wheels/2)
#Add brain and wheels parameter (Default: Adafruit ESP32 2 Stacks)
c.addParameter("brains", "esp32stack", paramType="dimension")
c.addParameter("driveservo", "fs90r", paramType="dimension")

#The height will always match the height of the brains
c.addParameter("length", 80, paramType="length", minValue=80) #tested minValue
c.addParameter("width", 60, paramType="length", minValue=60) #tested minValue
c.addParameter("steerangle", 3.14, paramType="length") #Change this to change direction of car

for i in range(n):
    c.addSubcomponent("car%d" % i, "HalfCar")
    c.addConstraint(("car%d" % i, "length"), ("length", "driveservo", "brains"), "(x[0] - (x[0]/2. - 2 * getDim(x[1], 'hornoffset')"
                                                                                 "- getDim(x[2], 'width')))")
    c.addConstraint(("car%d" % i, "height"), "brains", '(getDim(x, "height"))')
    c.addConstraint(("car%d" % i, "width"), "width")

#Putting the brains in front component of the car (Default: 1 Brain on car0)
c.addSubcomponent("holder", "ESP32Stack")
c.addConstraint(("holder", "length"), "width")

c.addSubcomponent("holdersplit", "SplitEdge")
c.addConstraint(("holdersplit", "toplength"), "brains", '(getDim(x, "height"),)')
c.addConstraint(("holdersplit", "botlength"),
                ("driveservo", "brains"),
                "(getDim(x[0], 'motorwidth'), getDim(x[1], 'height') - getDim(x[0], 'motorwidth'))")

c.addConnection(("holdersplit", "topedge0"), ("holder", "cover.topedge1"))
c.addConnection(("car0", "bright.topedge0"), ("holdersplit", "botedge0"), angle=-90)

#Putting servo hinge between cars
for i in range(n):
    c.addSubcomponent("hinge%d" %i, "Pivot", inherit="servo.angle")
    c.addConstraint(("hinge%d" %i, "length"), "length")
    c.addConstraint(("hinge%d" %i, "width"), "width")
    c.addSubcomponent("hingeSplit%d" %i, "SplitEdge")
    c.addConstraint(("hingeSplit%d" %i, "toplength"), "brains", '(getDim(x, "height"), )')
    c.addConstraint(("hingeSplit%d" %i, "botlength"), ("brains", "driveservo"),
                        '((getDim(x[0], "height")-getDim(x[1], "motorheight"))/2, getDim(x[1], "motorheight"), '
                        '(getDim(x[0], "height")-getDim(x[1], "motorheight"))/2)')
    c.addConnection(("car%d" %i, "rect2.l"), ("hingeSplit%d" %i, "topedge0"))
    c.addConnection(("hingeSplit%d" %i, "botedge1"), ("hinge%d" %i, "belt2.r"), angle=-90)

#Attach hinge on face of Trapezoid to move in Webots
#Main component of steering wheel car which makes them moveable: trapezoid that connects the two half of the car
for i in range(((n - 1) * 4)):
    c.addSubcomponent("midsupport%d" % i, "Trapezoid")
    c.addConstraint(("midsupport%d" % i, "width"), "width", "x-(2*x*.15)")
    c.addConstraint(("midsupport%d" % i, "depth"), "driveservo", "getDim(x, 'motorlength')")
    c.addConstraint(("midsupport%d" % i, "bangle"), ("width", "driveservo"),
                    "float(np.atan(getDim(x[1], 'motorlength')/(x[0]*.15))* 180 * 0.318309)")

w = 0
for j in range(1, (n-1), 1):
    for i in range(w, j * 4, 4):
        c.addConstraint(("hinge%d" % (j + 1), "servo.angle"), "steerangle")
        c.addConnection(("car%d" %j, "rect4.l"), ("midsupport%d" % i, "botedge"))
        c.addConnection(("car%d" % j, "rect4.r"), ("midsupport%d" % (i+1), "botedge"))
        c.addConnection(("car%d" % j, "rect3.l"), ("midsupport%d" % (i+2), "botedge"))
        c.addConnection(("car%d" % j, "rect3.r"), ("midsupport%d" % (i+3), "botedge"))
    w += 4

for j in range(0, n, n-1):
    for i in range(w, w + 2, 2):
        c.addConnection(("car%d" %j, "rect3.r"), ("midsupport%d" % i, "botedge"))
        c.addConnection(("car%d" % j, "rect4.r"), ("midsupport%d" % (i+1), "botedge"))
    w += 2


c.toLibrary("Centipede")
