from rocolib.api.components.Component import Component

c = Component()

c.addSubcomponent("boat","SimpleUChannel", inherit=True)
c.addSubcomponent("bow","BoatPoint", inherit=True)
c.addSubcomponent("stern","BoatPoint", inherit=True)

c.join(("boat", "top"), ("bow", "edge"))
c.join(("boat", "bot"), ("stern", "edge"))

c.inheritInterface("portedge", ("boat", "ledge"))
c.inheritInterface("staredge", ("boat", "redge"))

c.toLibrary("BoatBase")
